
#include <windows.h>
#include "resource.h"

#pragma comment(linker,"/FILEALIGN:512 /MERGE:.rdata=.text /MERGE:.data=.text /SECTION:.text,EWR /IGNORE:4078")

// functions
BOOL     CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
DWORD    WINAPI WndSelecterProc(PVOID);
VOID     UpdateGUI();

#define SelectingWnd() ((GetAsyncKeyState(VK_CONTROL) & 0x8000) ? TRUE : FALSE)

// structs
typedef struct
{
	HWND   hWnd;
	DWORD  dwID;
	CHAR   cWndClassName[200];
} sCurWnd;

// constants
CONST   CHAR*  szClassName          = "WindowMan";

// variables
sCurWnd			  CurWnd;
HANDLE            hDLG;
DWORD             dwWSPThread;
HANDLE            hWSPThread;
CHAR              cEditBuff[50];
HCURSOR           hcNormal;
HICON             hIcon;
CRITICAL_SECTION  CS;


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	WNDCLASS wc;

	hcNormal = LoadCursor(NULL,IDC_ARROW);
	hIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1));

	// register a class & create a dialog	
	ZeroMemory(&wc,sizeof(wc));
    wc.style =          CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc =    DlgProc;
    wc.hInstance =      hInstance;
    wc.hCursor =        hcNormal;
    wc.hbrBackground =  (HBRUSH)(COLOR_BTNFACE+1);
    wc.lpszClassName =  szClassName;
    RegisterClass(&wc);
	
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_MAINDLG), NULL,DlgProc);

	// clean up
	DeleteCriticalSection(&CS);
	return 0;
}

BOOL CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	RECT   rect;

	switch (uMsg)
	{
		case WM_INITDIALOG:
			hDLG = hDlg;
			SendMessage(hDlg,WM_SETICON,ICON_BIG,(LPARAM)hIcon);
			ZeroMemory(&CurWnd,sizeof(CurWnd));
			ZeroMemory(&CS,sizeof(CS));
			InitializeCriticalSection(&CS);
			hWSPThread = CreateThread(NULL,0,WndSelecterProc,NULL,0,&dwWSPThread);
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
			case IDC_DOCLICK:
				PostMessage(CurWnd.hWnd,BM_CLICK,0,0);
				break;

			case IDC_DODESTROY:
				PostMessage(CurWnd.hWnd,WM_DESTROY,0,0);
				break;

			case IDC_DOENABLE:
				EnableWindow(CurWnd.hWnd,TRUE);
				break;

			case IDC_DODISABLE:
				EnableWindow(CurWnd.hWnd,FALSE);
				break;

			case IDC_DOHIDE:
				ShowWindow(CurWnd.hWnd,SW_HIDE);
				break;

			case IDC_DOUNHIDE:
				ShowWindow(CurWnd.hWnd,SW_SHOW);
				break;

			case IDC_DOCHECK:
				PostMessage(CurWnd.hWnd,BM_SETCHECK,BST_CHECKED,0);
				break;

			case IDC_DOUNCHECK:
				PostMessage(CurWnd.hWnd,BM_SETCHECK,BST_UNCHECKED,0);
				break;

			case IDC_DOTOPMOST:
			case IDC_DONOTOPMOST:
				GetWindowRect(CurWnd.hWnd,&rect);
				SetWindowPos(
					CurWnd.hWnd,
					(LOWORD(wParam) == IDC_DOTOPMOST) ? HWND_TOPMOST : HWND_NOTOPMOST,
					rect.left,
					rect.top,
					rect.right - rect.left,
					rect.bottom - rect.top,
					0);
				break;
			}
			return TRUE;

		case WM_CLOSE:
			EndDialog(hDlg,0);
			return TRUE;
	}
	return FALSE;
}

DWORD WINAPI WndSelecterProc(PVOID pParam)
{
	POINT              p;
	HWND               hTarWnd;

	while(TRUE)
	{
		Sleep(50);
		if (SelectingWnd())
		{
			EnterCriticalSection(&CS);
			// get the handle of the window on which the cursor points currently
			GetCursorPos(&p);
			hTarWnd = WindowFromPoint(p);
			if (hTarWnd)
			{
				// update the contents of CurWnd
				CurWnd.hWnd = hTarWnd;
				GetClassName(
					hTarWnd,
					CurWnd.cWndClassName,
					sizeof(CurWnd));
				CurWnd.dwID = GetWindowLong(hTarWnd,GWL_ID);
				UpdateGUI();
			}
			LeaveCriticalSection(&CS);
		}
	}
	return 0;
}

VOID UpdateGUI()
{
	SetDlgItemText(hDLG,IDC_CLASSNAME,CurWnd.cWndClassName);
	wsprintf(cEditBuff,"0x%X",CurWnd.hWnd);
	SetDlgItemText(hDLG,IDC_HWND,cEditBuff);
	wsprintf(cEditBuff,"0x%X",CurWnd.dwID);
	SetDlgItemText(hDLG,IDC_ID,cEditBuff);
	return;
}